import { jsxs as et, jsx as k } from "react/jsx-runtime";
import { o as rt } from "../../chunks/useMergeRefs.DYDIMIZh.js";
import st, { useState as F, useRef as x, useLayoutEffect as E } from "react";
import { i as at, j as ot } from "../../chunks/index.mDmYomX5.js";
import { TEXT_AREA_WRAPPER_CLASSNAME as ct, r as lt, TEXT_AREA_CLASSNAME as G, TEXT_AREA_CONTROL_RIGHT_CLASSNAME as nt, TEXT_AREA_HELPER_TEXT_CLASSNAME as I } from "../../chunks/constants.D-rfPeOH.js";
import c from "clsx";
function it({
  value: t,
  defaultValue: s,
  finalValue: e,
  onChange: r = () => {
  }
}) {
  const [a, y] = F(
    s !== void 0 ? s : e
  );
  return t !== void 0 ? [t, r, !0] : [a, (n) => {
    y(n), r == null || r(n);
  }, !1];
}
const ut = () => "rounded-md text-base h-20 min-h-[80px] resize-none overflow-hidden px-4 py-7", ft = ({
  mode: t
}) => c({
  "bg-surface-darker text-copy-lighter caret-copy-light": t === "dark",
  "bg-surface-lighter text-copy-dark caret-copy-dark": t === "light",
  "bg-surface-lighter text-copy-dark caret-copy-dark dark:bg-surface-darker dark:text-copy-lighter dark:caret-copy-light": t === "system",
  "bg-surface-darker text-copy-lighter caret-copy-light dark:bg-surface-lighter dark:text-copy-dark dark:caret-copy-dark": t === "alt-system"
}), dt = ({
  focusMode: t
}) => c("focus:outline focus:outline-2 focus:outline-offset-2", {
  "focus:outline-focus-dark": t === "dark",
  "focus:outline-focus-light": t === "light",
  "focus:outline-focus-light dark:focus:outline-focus-dark": t === "alt-system",
  "focus:outline-focus-dark dark:focus:outline-focus-light": t === "system"
}), pt = ({
  noBorder: t,
  error: s
}) => c("border-2", {
  "border-border-dark": !t && !s,
  "focus:border-border-dark": !t && s,
  "border-border-error-dark": !t && s,
  "border-transparent": t
}), xt = ({
  disabled: t,
  raw: s,
  error: e,
  mode: r
}) => {
  if (s)
    return "";
  if (t)
    return c("absolute px-2 cursor-not-allowed opacity-50 font-medium");
  if (!e)
    return c("absolute px-2 cursor-text font-medium", {
      "text-copy-medium": r === "dark",
      "text-copy-dark": r === "light",
      "text-copy-dark dark:text-copy-medium": r === "system",
      "text-copy-medium dark:text-copy-dark": r === "alt-system"
    });
  if (e)
    return c("absolute px-2 cursor-text font-medium", {
      "text-copy-medium": r === "dark",
      "text-copy-error-dark": r === "light",
      "text-copy-error-dark dark:text-copy-error-light": r === "system",
      "text-copy-medium dark:text-copy-error-dark": r === "alt-system"
    });
}, yt = ({
  error: t,
  raw: s,
  mode: e,
  disabled: r
}) => {
  if (s)
    return "";
  if (r)
    return c(
      I,
      "absolute px-2 cursor-not-allowed opacity-50 font-medium"
    );
  if (!t)
    return c(I, "absolute px-2 font-medium", {
      "text-copy-medium": e === "dark",
      "text-copy-dark": e === "light",
      "text-copy-dark dark:text-copy-medium": e === "system",
      "text-copy-medium dark:text-copy-dark": e === "alt-system"
    });
  if (t)
    return c(I, "absolute px-2 font-medium", {
      "text-copy-error-light": e === "dark",
      "text-copy-error-dark": e === "light",
      "text-copy-error-dark dark:text-copy-error-light": e === "system",
      "dark:text-copy-error-dark text-copy-error-light": e === "alt-system"
    });
}, ht = ({
  className: t,
  textAreaClassName: s,
  raw: e,
  focusMode: r,
  disabled: a,
  noBorder: y,
  error: l,
  spacing: n,
  mode: i
}) => {
  const h = e ? t : c(
    "relative flex w-full flex-col justify-center",
    ct,
    t,
    lt(n)
  ), R = e ? c(s) : c(
    G,
    s,
    ut(),
    ft({ mode: i }),
    dt({ focusMode: r }),
    pt({
      noBorder: y,
      error: l
    }),
    {
      "disabled:cursor-not-allowed disabled:opacity-50": a
    }
  ), b = e ? void 0 : "sr-only", _ = xt({
    disabled: a,
    raw: e,
    error: l,
    mode: i
  }), L = yt({
    error: l,
    raw: e,
    mode: i,
    disabled: a
  }), u = e ? void 0 : c(nt, "absolute");
  return {
    wrapper: h,
    textArea: R,
    accessibleLabel: b,
    visibleLabel: _,
    helperText: L,
    rightElement: u
  };
}, gt = ({
  scrollHeight: t,
  currentHeight: s,
  currentLabelOffset: e = 0,
  currentHelperTextOffset: r = 0
}) => {
  let l, n;
  if (t > 0 && t !== s) {
    const i = t - s, h = Math.abs(i / 24);
    l = e + -1 * Math.sign(i) * (12 * h), n = r + Math.sign(i) * (12 * h);
  }
  return {
    labelOffset: l,
    helperTextOffset: n,
    scrollHeight: t
  };
}, kt = st.forwardRef(
  ({
    id: t,
    name: s,
    label: e,
    error: r = !1,
    raw: a = !1,
    className: y,
    textAreaClassName: l,
    mode: n = "system",
    focusMode: i = "system",
    value: h,
    defaultValue: R,
    disabled: b = !1,
    noBorder: _ = !1,
    labelId: L,
    helperText: u = "",
    helperTextOnFocus: N = !1,
    rightElement: m,
    onChange: P,
    onFocus: $,
    onBlur: j,
    spacing: V,
    ...z
  }, B) => {
    const f = x(null), D = rt([B, f]), T = x(null), C = x(80), M = x(-25), p = x(null), W = x(30), v = x(null), A = at({ id: t, prefix: `${G}-` }), [U, q] = F(0), [J, X] = F(
      !!(!N && u)
    ), K = `${s} error, ${u}`, g = ht({
      className: y,
      textAreaClassName: l,
      error: r,
      raw: a,
      focusMode: i,
      disabled: b,
      noBorder: _,
      spacing: V,
      mode: n
    }), [d, Q] = it({
      value: h,
      defaultValue: R,
      onChange: (o) => {
        P && P({
          target: {
            value: o
          }
        });
      }
    }), Y = (o) => {
      Q(o.target.value);
    }, Z = (o) => {
      N && u && X(!0), $ && $(o);
    }, w = (o) => {
      N && u && !d && X(!1), j && j(o);
    };
    return E(() => {
      !a && m && T.current && T.current.offsetWidth > 0 && q(T.current.offsetWidth + 18 + 10);
    }, [m, a]), E(() => {
      a || f && f.current && d !== void 0 && (f.current.style.height = "inherit", f.current.style.height = f.current.scrollHeight + "px");
    }, [d, a]), E(() => {
      a || setTimeout(() => {
        var o;
        (o = p == null ? void 0 : p.current) == null || o.style.setProperty(
          "--av-text-area-wrapper-transition",
          d ? "none" : "all 0.2s ease-out"
        );
      }, 0);
    }, [d, a]), E(() => {
      var o, O;
      if (!a && f && f.current && d !== void 0) {
        const { labelOffset: S, helperTextOffset: H, scrollHeight: tt } = gt({
          scrollHeight: f.current.scrollHeight,
          currentHeight: C.current,
          currentLabelOffset: M.current,
          currentHelperTextOffset: W.current
        });
        S && (M.current = S, (o = p == null ? void 0 : p.current) == null || o.style.setProperty(
          "--av-text-area-label",
          `${S}px`
        )), H && (W.current = H, (O = v == null ? void 0 : v.current) == null || O.style.setProperty(
          "--av-text-area-helper-text",
          `${H}px`
        )), C.current = tt || C.current;
      }
    }, [d, a]), /* @__PURE__ */ et("div", { className: g.wrapper, children: [
      /* @__PURE__ */ k(
        "label",
        {
          htmlFor: A,
          id: L,
          className: g.accessibleLabel,
          children: e
        }
      ),
      /* @__PURE__ */ k(
        "textarea",
        {
          ref: D,
          id: A,
          name: s,
          disabled: b,
          placeholder: a ? void 0 : " ",
          className: g.textArea,
          rows: 1,
          ...u && { "aria-describedby": `${A}-helper` },
          ...r && { "aria-invalid": "true" },
          ...m && !a && { style: { paddingRight: U } },
          value: d,
          onChange: Y,
          onFocus: Z,
          onBlur: w,
          ...z
        }
      ),
      !a && /* @__PURE__ */ k(
        "label",
        {
          ref: p,
          "aria-hidden": !0,
          htmlFor: A,
          className: g.visibleLabel,
          children: e
        }
      ),
      J && /* @__PURE__ */ k(
        "div",
        {
          ref: v,
          id: `${A}-helper`,
          className: g.helperText,
          children: u
        }
      ),
      m && /* @__PURE__ */ k(
        "div",
        {
          ref: T,
          className: g.rightElement,
          children: m
        }
      ),
      r && u && /* @__PURE__ */ k(ot, { politeness: "polite", clearAnnouncementDelay: 500, children: K })
    ] });
  }
);
kt.displayName = "TextArea";
export {
  kt as TextArea
};
