import { jsxs as w, jsx as p } from "react/jsx-runtime";
import F, { useRef as E, useEffect as I, useCallback as $, useState as v, useMemo as j, useLayoutEffect as X } from "react";
import { i as U, j as H } from "../../chunks/index.mDmYomX5.js";
import { TEXT_INPUT_WRAPPER_CLASSNAME as M, r as q, TEXT_INPUT_CLASSNAME as N, TEXT_INPUT_HELPER_TEXT_CLASSNAME as T } from "../../chunks/constants.D-rfPeOH.js";
import a from "clsx";
function z() {
  const t = E(!1);
  return I(() => (t.current = !0, () => {
    t.current = !1;
  }), []), $(() => t.current, []);
}
const D = {
  x: 0,
  y: 0,
  width: 0,
  height: 0,
  top: 0,
  left: 0,
  bottom: 0,
  right: 0
};
function O(t) {
  const s = z(), e = E(0), r = E(null), [o, i] = v(D), c = j(
    () => typeof window < "u" ? new ResizeObserver((l) => {
      const n = l[0];
      n && (cancelAnimationFrame(e.current), e.current = requestAnimationFrame(() => {
        r.current && s() && i(n.contentRect);
      }));
    }) : null,
    [s]
  );
  return I(() => (r.current && (c == null || c.observe(r.current, t)), () => {
    c == null || c.disconnect(), e.current && cancelAnimationFrame(e.current);
  }), [c, t]), [r, o];
}
const W = ({
  mode: t
}) => a({
  "bg-surface-darker text-copy-lighter caret-copy-light": t === "dark",
  "bg-surface-lighter text-copy-dark caret-copy-dark": t === "light",
  "bg-surface-lighter text-copy-dark caret-copy-dark dark:bg-surface-darker dark:text-copy-lighter dark:caret-copy-light": t === "system",
  "bg-surface-darker text-copy-lighter caret-copy-light dark:bg-surface-lighter dark:text-copy-dark dark:caret-copy-dark": t === "alt-system"
}), G = ({
  focusMode: t
}) => a("focus:outline focus:outline-2 focus:outline-offset-2", {
  "focus:outline-focus-dark": t === "dark",
  "focus:outline-focus-light": t === "light",
  "focus:outline-focus-light dark:focus:outline-focus-dark": t === "alt-system",
  "focus:outline-focus-dark dark:focus:outline-focus-light": t === "system"
}), J = ({
  noBorder: t,
  error: s
}) => a("border-2", {
  "border-border-dark": !t && !s,
  "focus:border-border-dark": !t && s,
  "border-border-error-dark": !t && s,
  "border-transparent": t
}), K = ({
  disabled: t,
  raw: s,
  error: e,
  mode: r
}) => {
  if (s)
    return "";
  if (t)
    return a("absolute px-2 cursor-not-allowed opacity-50 font-medium");
  if (!e)
    return a("absolute px-2 cursor-text font-medium", {
      "text-copy-lighter": r === "dark",
      "text-copy-dark": r === "light",
      "text-copy-dark dark:text-copy-lighter": r === "system",
      "text-copy-lighter dark:text-copy-dark": r === "alt-system"
    });
  if (e)
    return a("absolute px-2 cursor-text font-medium", {
      "text-copy-lighter": r === "dark",
      "text-copy-error-dark": r === "light",
      "text-copy-error-dark dark:text-copy-error-light dark:bg-surface-darker": r === "system",
      "text-copy-lighter dark:text-copy-error-dark": r === "alt-system"
    });
}, Q = ({
  error: t,
  raw: s,
  mode: e,
  disabled: r
}) => {
  if (s)
    return "";
  if (r)
    return a(
      T,
      "absolute px-2 cursor-not-allowed opacity-50 font-medium"
    );
  if (!t)
    return a(T, "absolute px-2 font-medium", {
      "text-copy-lighter": e === "dark",
      "text-copy-dark": e === "light",
      "text-copy-dark dark:text-copy-lighter": e === "system",
      "text-copy-lighter dark:text-copy-dark": e === "alt-system"
    });
  if (t)
    return a(T, "absolute px-2 font-medium", {
      "text-copy-error-light bg-surface-darker": e === "dark",
      "text-copy-error-dark": e === "light",
      "text-copy-error-dark dark:text-copy-error-light dark:bg-surface-darker": e === "system",
      "dark:text-copy-error-dark text-copy-error-light bg-surface-darker": e === "alt-system"
    });
}, V = ({
  className: t,
  inputClassName: s,
  raw: e,
  disabled: r,
  noBorder: o,
  error: i,
  spacing: c,
  mode: l,
  focusMode: n
}) => {
  const y = e ? t : a(
    "relative flex w-full flex-col justify-center",
    M,
    t,
    q(c)
  ), x = e ? a(s) : a(
    N,
    s,
    "h-12 rounded-md px-4 text-base",
    W({ mode: l }),
    G({ focusMode: n }),
    J({ noBorder: o, error: i }),
    {
      "disabled:cursor-not-allowed disabled:opacity-50": r
    }
  ), k = e ? void 0 : "sr-only", h = K({
    disabled: r,
    raw: e,
    error: i,
    mode: l
  }), b = Q({
    error: i,
    raw: e,
    mode: l,
    disabled: r
  });
  return {
    wrapper: y,
    input: x,
    accessibleLabel: k,
    visibleLabel: h,
    helperText: b,
    rightElement: e ? void 0 : "absolute right-3"
  };
}, Y = F.forwardRef(
  ({
    id: t,
    name: s,
    label: e,
    error: r = !1,
    raw: o = !1,
    className: i,
    inputClassName: c,
    mode: l = "system",
    focusMode: n = "system",
    disabled: y = !1,
    noBorder: x = !1,
    labelId: k,
    labelHidden: h = !1,
    type: b = "text",
    helperText: u = "",
    rightElement: m,
    spacing: R,
    ...A
  }, C) => {
    const [L, g] = O(), [_, P] = v(0), f = U({ id: t, prefix: `${N}-` }), S = `${s} error, ${u}`, d = V({
      className: i,
      inputClassName: c,
      error: r,
      raw: o,
      focusMode: n,
      disabled: y,
      noBorder: x,
      spacing: R,
      mode: l
    });
    return X(() => {
      g && g.width && P(g.width + 18 + 10);
    }, [g]), /* @__PURE__ */ w("div", { className: d.wrapper, children: [
      /* @__PURE__ */ p(
        "label",
        {
          htmlFor: f,
          id: k,
          className: d.accessibleLabel,
          children: e
        }
      ),
      /* @__PURE__ */ p(
        "input",
        {
          ref: C,
          id: f,
          name: s,
          type: b,
          disabled: y,
          placeholder: o ? void 0 : " ",
          className: d.input,
          ...u && { "aria-describedby": `${f}-helper` },
          ...r && { "aria-invalid": "true" },
          ...m && !o && { style: { paddingRight: _ } },
          ...A
        }
      ),
      !o && !h && /* @__PURE__ */ p(
        "label",
        {
          "aria-hidden": !0,
          htmlFor: f,
          className: d.visibleLabel,
          children: e
        }
      ),
      u && /* @__PURE__ */ p(
        "div",
        {
          id: `${f}-helper`,
          className: d.helperText,
          children: u
        }
      ),
      m && /* @__PURE__ */ p(
        "div",
        {
          ref: L,
          className: d.rightElement,
          children: m
        }
      ),
      r && u && /* @__PURE__ */ p(H, { politeness: "polite", clearAnnouncementDelay: 500, children: S })
    ] });
  }
);
Y.displayName = "TextInput";
export {
  Y as TextInput
};
